Index: src/test/java/com/xpn/xwiki/render/XWikiRadeoxRendererTest.java
===================================================================
--- src/test/java/com/xpn/xwiki/render/XWikiRadeoxRendererTest.java	(revision 3976)
+++ src/test/java/com/xpn/xwiki/render/XWikiRadeoxRendererTest.java	(working copy)
@@ -26,6 +26,7 @@
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiConfig;
 import com.xpn.xwiki.web.XWikiURLFactory;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 
 import java.net.URL;
@@ -88,7 +89,7 @@
 
         Mock mockUrlFactory = mock(XWikiURLFactory.class);
         mockUrlFactory.expects(once()).method("createURL").with(new Constraint[] {
-            eq("Main"), eq("new link"), eq("edit"), eq("parent=Main.WebHome"), ANYTHING, ANYTHING})
+            eq("Main"), eq("new link"), eq(DocumentAction.EDIT), eq("parent=Main.WebHome"), ANYTHING, ANYTHING})
             .will(returnValue(new URL("http://server.com/Main/new link")));
         mockUrlFactory.expects(atLeastOnce()).method("getURL").will(returnValue("/Main/new link"));
         this.context.setURLFactory((XWikiURLFactory) mockUrlFactory.proxy());
Index: src/test/java/com/xpn/xwiki/api/TestAccessLevel.java
===================================================================
--- src/test/java/com/xpn/xwiki/api/TestAccessLevel.java	(revision 0)
+++ src/test/java/com/xpn/xwiki/api/TestAccessLevel.java	(revision 0)
@@ -0,0 +1,135 @@
+package com.xpn.xwiki.api;
+
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.List;
+
+import junit.framework.TestCase;
+
+public class TestAccessLevel extends TestCase
+{
+
+    public void testValues()
+    {
+        // test them to be more than the constants defined in the class
+        int expectedCount = 9;
+        AccessLevel[] levels = AccessLevel.values();
+        assertTrue(expectedCount <= levels.length);
+    }
+
+    public void testIsAccessLevelDefined()
+    {
+        String expectedDefined = "login";
+        String expectedUndefined = "logout";
+
+        assertTrue(AccessLevel.isAccessLevelDefined(expectedDefined));
+        assertFalse(AccessLevel.isAccessLevelDefined(expectedUndefined));
+    }
+
+    public void testValueOfString()
+    {
+        AccessLevel expected = AccessLevel.LOGIN;
+        String accessLevelString1 = "login";
+        String accessLevelString2 = "Login";
+        String accessLevelString3 = " login";
+        String accessLevelString4 = "log in";
+        assertSame(expected, AccessLevel.valueOf(accessLevelString1));
+        assertSame(expected, AccessLevel.valueOf(accessLevelString2));
+        assertSame(expected, AccessLevel.valueOf(accessLevelString3));
+        assertNotSame(expected, AccessLevel.valueOf(accessLevelString4));
+
+        ArrayList beforeList = new ArrayList(Arrays.asList(AccessLevel.values()));
+        AccessLevel newAccessLevel1 = AccessLevel.valueOf("testValueOfString1");
+        AccessLevel newAccessLevel2 = AccessLevel.valueOf("testvalueOfString1  ");
+        
+        ArrayList afterList = new ArrayList(Arrays.asList(AccessLevel.values()));
+        List regularAccessLevels = AccessLevel.listRegularAccessLevels();
+        List globalAccessLevels = AccessLevel.listGlobalAccessLevels();
+
+        assertSame(newAccessLevel1, newAccessLevel2);
+        assertFalse(beforeList.contains(newAccessLevel1));
+        assertFalse(regularAccessLevels.contains(newAccessLevel1));
+        assertFalse(globalAccessLevels.contains(newAccessLevel1));
+        assertTrue(afterList.contains(newAccessLevel1));
+    }
+
+    public void testValueOfStringBooleanBoolean()
+    {
+        // same behaviour as the valueOfString
+        AccessLevel expected = AccessLevel.LOGIN;
+        String accessLevelString1 = "login";
+        String accessLevelString2 = "Login";
+        String accessLevelString3 = " login";
+        String accessLevelString4 = "log in";
+        assertSame(expected, AccessLevel.valueOf(accessLevelString1));
+        assertSame(expected, AccessLevel.valueOf(accessLevelString2));
+        assertSame(expected, AccessLevel.valueOf(accessLevelString3));
+        assertNotSame(expected, AccessLevel.valueOf(accessLevelString4));
+
+        // different behaviour
+        ArrayList beforeList = new ArrayList(Arrays.asList(AccessLevel.values()));
+        boolean isRegular = true;
+        boolean isGlobal = false;
+        AccessLevel newAccessLevel =
+            AccessLevel.valueOf("testValueOfStringBooleanBoolean1", isRegular, isGlobal);
+        
+        ArrayList afterList = new ArrayList(Arrays.asList(AccessLevel.values()));
+        List regularAccessLevels = AccessLevel.listRegularAccessLevels();
+        List globalAccessLevels = AccessLevel.listGlobalAccessLevels();
+
+        assertFalse(beforeList.contains(newAccessLevel));
+        assertTrue(regularAccessLevels.contains(newAccessLevel) == isRegular);
+        assertTrue(globalAccessLevels.contains(newAccessLevel) == isGlobal);
+        assertTrue(afterList.contains(newAccessLevel));
+
+        // test can't change existing settings
+        AccessLevel newAccessLevelChange =
+            AccessLevel.valueOf("testValueOfStringBooleanBoolean1", isRegular, isGlobal);
+        assertTrue(regularAccessLevels.contains(newAccessLevelChange) == isRegular);
+        assertTrue(globalAccessLevels.contains(newAccessLevelChange) == isGlobal);
+    }
+
+    public void testListRegularAccessLevels()
+    {
+        List regularAccessLevels = AccessLevel.listRegularAccessLevels();
+        // must have at least edit, view, comment
+        int expectedCount = 3;
+        assertTrue(expectedCount <= regularAccessLevels.size());
+        assertTrue(regularAccessLevels.contains(AccessLevel.EDIT));
+        assertTrue(regularAccessLevels.contains(AccessLevel.VIEW));
+        assertTrue(regularAccessLevels.contains(AccessLevel.COMMENT));
+    }
+
+    public void testListGlobalAccessLevels()
+    {
+        List globalAccessLevels = AccessLevel.listGlobalAccessLevels();
+        // must have at least admin, view, edit, comment, delete, register, programming
+        int expectedCount = 7;
+        assertTrue(expectedCount <= globalAccessLevels.size());
+        assertTrue(globalAccessLevels.contains(AccessLevel.ADMIN));
+        assertTrue(globalAccessLevels.contains(AccessLevel.VIEW));
+        assertTrue(globalAccessLevels.contains(AccessLevel.EDIT));
+        assertTrue(globalAccessLevels.contains(AccessLevel.COMMENT));
+        assertTrue(globalAccessLevels.contains(AccessLevel.DELETE));
+        assertTrue(globalAccessLevels.contains(AccessLevel.REGISTER));
+        assertTrue(globalAccessLevels.contains(AccessLevel.PROGRAMMING));
+    }
+
+    public void testToString()
+    {
+        String expected1 = "login";
+        assertEquals(AccessLevel.LOGIN.toString(), expected1);
+        String expected2 = "testtostring1";
+        assertEquals(AccessLevel.valueOf("testToString1").toString(), expected2);
+        assertEquals(AccessLevel.valueOf("   testToString1 ").toString(), expected2);
+    }
+
+    public void testGetRightString()
+    {
+        String expected1 = "login";
+        assertEquals(AccessLevel.LOGIN.getRightString(), expected1);
+        String expected2 = "testgetrightstring1";
+        assertEquals(AccessLevel.valueOf("testGetRightString1").getRightString(), expected2);
+        assertEquals(AccessLevel.valueOf("   testGetRightString1 ").getRightString(), expected2);
+    }
+}
Index: src/test/java/com/xpn/xwiki/api/TestDocumentAction.java
===================================================================
--- src/test/java/com/xpn/xwiki/api/TestDocumentAction.java	(revision 0)
+++ src/test/java/com/xpn/xwiki/api/TestDocumentAction.java	(revision 0)
@@ -0,0 +1,154 @@
+/*
+ * Copyright 2004-2007, XpertNet SARL, and individual contributors.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ *
+ *
+ * This distribution includes the following modules:
+ *
+ * http://jakarta.apache.org: velocity, struts, jrcs, commons, etc..
+ * This distribution also includes libraries from the Apache Software
+ * Foundation distributed under the terms of the Apache Software License.
+ * See http://www.opensource.org/licenses/apachepl.php
+ *
+ * http://www.hibernate.org:
+ * This distribution includes libraries from hibernate.org distributed
+ * under the terms of the Lesser General Public License.
+ * See http://www.gnu.org/copyleft/lesser.html
+ *
+ * http://www.junit.org
+ * This distribution includes libraries from junit.org distributed 
+ * under the terms of the Common Public License
+ * See http://www.opensource.org/licenses/cpl.php
+ *
+ * ===================================================================
+ */
+package com.xpn.xwiki.api;
+
+import java.util.Arrays;
+import java.util.Comparator;
+
+import junit.framework.TestCase;
+
+public class TestDocumentAction extends TestCase
+{
+    public void testValues()
+    {
+        //we'll test them to be exactly or more than 38 (maybe some other action has been defined in 
+        //the mean time).
+        DocumentAction[] actions = DocumentAction.values();
+        assertTrue(38 <= actions.length);
+    }
+
+    public void testGetAction()
+    {
+        //lowercase, trimmed
+        String expected = "view";
+        assertEquals(DocumentAction.VIEW.getAction(), expected);
+        String notExpected1 = "View";
+        assertFalse(DocumentAction.VIEW.getAction().equals(notExpected1));
+        String notExpected2 = " view";
+        assertFalse(DocumentAction.VIEW.getAction().equals(notExpected2));
+    }
+
+    public void testValueOf()
+    {
+        DocumentAction expected = DocumentAction.EDIT;
+        DocumentAction actual1 = DocumentAction.valueOf(" edit");
+        DocumentAction actual2 = DocumentAction.valueOf("EDIT");
+        DocumentAction actual3 = DocumentAction.valueOf("edit");
+        //must be THE SAME object
+        assertSame(expected, actual1);
+        assertSame(expected, actual2);
+        assertSame(expected, actual3);
+        
+        //get the values
+        DocumentAction[] existingValues = DocumentAction.values();
+        //now let's create a new action and then ask for it
+        DocumentAction actual4 = DocumentAction.valueOf("editing");
+        //should not be in values
+        Comparator comparator = new Comparator()
+        {
+            public int compare(java.lang.Object da1, java.lang.Object da2)
+            {
+                return da1.hashCode() - da2.hashCode();
+            }
+        };
+        Arrays.sort(existingValues, comparator);
+        int sResult = Arrays.binarySearch(existingValues, actual4, comparator);
+        assertFalse(sResult >= 0);
+        //now get the same value, again and test for the same object
+        DocumentAction actual5 = DocumentAction.valueOf("editing");
+        assertSame(actual4, actual5);
+        DocumentAction actual6 = DocumentAction.valueOf("Editing");
+        assertSame(actual4, actual6);
+    }
+    
+    public void testIsActionDefined() 
+    {
+        //test for an existing action, let's say, view
+        String actionString1 = "view";
+        assertTrue(DocumentAction.isActionDefined(actionString1));
+        String actionString2 = "View";
+        assertTrue(DocumentAction.isActionDefined(actionString2));
+        //create a new action and test for it
+        String actionString3 = "newActionActDefTest";
+        assertFalse(DocumentAction.isActionDefined(actionString3));
+        DocumentAction.valueOf(actionString3);
+        assertTrue(DocumentAction.isActionDefined(actionString3));
+    }
+
+    public void testEqualsObject()
+    {
+        DocumentAction editDA1 = DocumentAction.ADMIN;
+        DocumentAction editDA2 = DocumentAction.valueOf("admin");
+        
+        //of my knowledge this tests using the equals function
+        assertEquals(editDA1, editDA2);
+        
+        //another test: two newly created elements, test for equality
+        DocumentAction newAction1 = DocumentAction.valueOf("newAction");
+        DocumentAction newAction2 = DocumentAction.valueOf(" NewAction ");
+        assertEquals(newAction1, newAction2);
+    }
+    
+    public void testGetAccessLevel() 
+    {
+        DocumentAction loginAction = DocumentAction.LOGIN;
+        AccessLevel expectedAccess = AccessLevel.LOGIN;
+        AccessLevel actualAccess = DocumentAction.getAccessLevel(loginAction);
+        assertSame(expectedAccess, actualAccess);
+        
+        DocumentAction loginAction2 = DocumentAction.valueOf(" login ");
+        AccessLevel actualAccess2 = loginAction2.getAccessLevel();
+        assertSame(expectedAccess, actualAccess2);
+    }
+    
+    public void testValueOfRight() 
+    {
+        //try to change the access level
+        AccessLevel beforeAccess = DocumentAction.getAccessLevel(DocumentAction.LOGIN);
+        DocumentAction.valueOf("login", AccessLevel.ADMIN);
+        AccessLevel afterAccess = DocumentAction.getAccessLevel(DocumentAction.LOGIN);
+        assertSame(beforeAccess, afterAccess);
+        
+        //create a new action with an access level defined
+        DocumentAction theNewAction = DocumentAction.valueOf("testValueOfRight1", AccessLevel.VIEW);
+        AccessLevel actual = DocumentAction.getAccessLevel(theNewAction);
+        assertSame(actual, AccessLevel.VIEW);
+    }
+
+}
Index: src/test/java/com/xpn/xwiki/plugin/zipexplorer/ZipExplorerTest.java
===================================================================
--- src/test/java/com/xpn/xwiki/plugin/zipexplorer/ZipExplorerTest.java	(revision 3976)
+++ src/test/java/com/xpn/xwiki/plugin/zipexplorer/ZipExplorerTest.java	(working copy)
@@ -24,6 +24,7 @@
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.objects.classes.ListItem;
 import com.xpn.xwiki.api.Document;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiAttachment;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.web.XWikiRequest;
@@ -60,23 +61,23 @@
     {
         assertTrue(this.plugin.isValidZipURL(
             "http://server/xwiki/bin/download/Main/Document/zipfile.zip/Directory/File.txt",
-            "download"));
+            DocumentAction.DOWNLOAD));
         assertFalse(this.plugin.isValidZipURL(
             "http://server/xwiki/bin/download/Main/Document/zipfile.zip/Directory/File.txt",
-            "view"));
+            DocumentAction.VIEW));
         assertFalse(this.plugin.isValidZipURL(
-            "http://server/xwiki/bin/download/Main/Document/zipfile.zip", "download"));
+            "http://server/xwiki/bin/download/Main/Document/zipfile.zip", DocumentAction.DOWNLOAD));
         assertFalse(this.plugin.isValidZipURL(
-            "http://server/xwiki/bin/download/Main/Document", "download"));
+            "http://server/xwiki/bin/download/Main/Document", DocumentAction.DOWNLOAD));
 
         // These tests should normally fail but we haven't implemented the check to verify if the
         // ZIP URL points to a file rather than a dir.
         assertTrue(this.plugin.isValidZipURL(
             "http://server/xwiki/bin/download/Main/Document/zipfile.zip/Directory/Dir2/",
-            "download"));
+            DocumentAction.DOWNLOAD));
         assertTrue(this.plugin.isValidZipURL(
             "http://server/xwiki/bin/download/Main/Document/zipfile.zip/Directory/Dir2",
-            "download"));
+            DocumentAction.DOWNLOAD));
     }
 
     public void testDownloadAttachmentWithInvalidZipURL() throws Exception {
@@ -176,10 +177,10 @@
         String urlPrefix = "server/xwiki/bin/download/Main/Document/zipfile.zip";
 
         assertEquals("Directory/File.txt", this.plugin.getFileLocationFromZipURL(
-            urlPrefix + "/Directory/File.txt", "download"));
-        assertEquals("", this.plugin.getFileLocationFromZipURL(urlPrefix, "download"));
+            urlPrefix + "/Directory/File.txt", DocumentAction.DOWNLOAD));
+        assertEquals("", this.plugin.getFileLocationFromZipURL(urlPrefix, DocumentAction.DOWNLOAD));
         assertEquals("Some Directory/File WithSpace.txt",  this.plugin.getFileLocationFromZipURL(
-            urlPrefix + "/Some%20Directory/File%20WithSpace.txt", "download"));
+            urlPrefix + "/Some%20Directory/File%20WithSpace.txt", DocumentAction.DOWNLOAD));
     }
 
     private XWikiDocument createXWikiDocumentWithZipFileAttachment() throws Exception {
@@ -197,7 +198,7 @@
         mockRequest.expects(once()).method("getRequestURI").will(returnValue(url));
         XWikiContext context = new XWikiContext();
         context.setRequest((XWikiRequest) mockRequest.proxy());
-        context.setAction("download");
+        context.setAction(DocumentAction.DOWNLOAD);
         return context;
     }
 
Index: src/main/java/com/xpn/xwiki/render/XWikiWikiBaseRenderer.java
===================================================================
--- src/main/java/com/xpn/xwiki/render/XWikiWikiBaseRenderer.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/render/XWikiWikiBaseRenderer.java	(working copy)
@@ -25,6 +25,7 @@
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.plugin.XWikiPluginManager;
 import com.xpn.xwiki.util.Util;
@@ -96,7 +97,7 @@
         output.append(start);
         if (!doc.isNew()) {
             output.append("<a href=\"");
-            output.append(doc.getURL("view", context));
+            output.append(doc.getURL(DocumentAction.VIEW, context));
             if ((anchor != null)&&(!anchor.equals(""))) {
               output.append("#");
               output.append(anchor);
@@ -108,7 +109,7 @@
             output.append("<span class=\"newtopiclink\">");
             output.append(link);
             output.append("</span><a href=\"");
-            output.append(doc.getURL("edit", context));
+            output.append(doc.getURL(DocumentAction.EDIT, context));
             output.append("?parent=");
             output.append(parentdoc.getFullName());
             output.append("\">?</a>");
Index: src/main/java/com/xpn/xwiki/render/filter/XWikiHeadingFilter.java
===================================================================
--- src/main/java/com/xpn/xwiki/render/filter/XWikiHeadingFilter.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/render/filter/XWikiHeadingFilter.java	(working copy)
@@ -21,6 +21,8 @@
 
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.AccessLevel;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.render.XWikiRadeoxRenderEngine;
 import com.xpn.xwiki.util.TOCGenerator;
@@ -119,7 +121,8 @@
         // Only show the section edit button for view action and when the user has edit rights on
         // the current document
         boolean showEditButton = false;
-        if (xcontext.getWiki().hasSectionEdit(xcontext) && ("view".equals(xcontext.getAction()))) {
+        if (xcontext.getWiki().hasSectionEdit(xcontext) 
+                && (DocumentAction.VIEW.equals(xcontext.getAction()))) {
             try {
                 // TODO: The user should always be set and never be null when this code gets
                 // executed. Unfortunately this is currently happening. It should be set to XWiki
@@ -129,7 +132,7 @@
                 // document and that doesn't make sense... 
                 if ((doc != null) && ((xcontext.getUser() != null)
                     && xcontext.getWiki().getRightService().hasAccessLevel(
-                    "edit", xcontext.getUser(), doc.getFullName(), xcontext)))
+                    AccessLevel.EDIT, xcontext.getUser(), doc.getFullName(), xcontext)))
                 {
                     showEditButton = true;
                 }
@@ -167,7 +170,7 @@
                     } catch (XWikiException e) {
                     }
 
-                    String url = doc.getURL("edit", editparams.toString(), xcontext);
+                    String url = doc.getURL(DocumentAction.EDIT, editparams.toString(), xcontext);
                     return heading + "<span class='edit_section'>&#91;"
                         + "<a style='text-decoration: none;' title='Edit section: "
                         + text.replaceAll("'", "&#39;") + "' href='" + url + "'>" + "edit"
Index: src/main/java/com/xpn/xwiki/render/macro/ImageMacro.java
===================================================================
--- src/main/java/com/xpn/xwiki/render/macro/ImageMacro.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/render/macro/ImageMacro.java	(working copy)
@@ -28,6 +28,7 @@
 import org.radeox.macro.parameter.MacroParameter;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.render.XWikiRadeoxRenderEngine;
 
@@ -155,14 +156,15 @@
             str.append("<div class=\"img" + halign.trim() + "\">");
         }
         if (link != null) {
-            str.append("<a href=\"" + doc.getAttachmentURL(img, "download", xcontext) + "\">");
+            str.append("<a href=\""
+                + doc.getAttachmentURL(img, DocumentAction.DOWNLOAD, xcontext) + "\">");
         }
         str.append("<img src=\"");
 
         if (img.indexOf("tp://") != -1) {
             str.append(img);
         } else {
-            str.append(doc.getAttachmentURL(img, "download", downloadParams, xcontext));
+            str.append(doc.getAttachmentURL(img, DocumentAction.DOWNLOAD, downloadParams, xcontext));
         }
         str.append("\" ");
         if (heightSpecified) {
Index: src/main/java/com/xpn/xwiki/render/macro/StyleMacro.java
===================================================================
--- src/main/java/com/xpn/xwiki/render/macro/StyleMacro.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/render/macro/StyleMacro.java	(working copy)
@@ -31,6 +31,7 @@
 
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.doc.XWikiAttachment;
 import com.xpn.xwiki.render.XWikiRadeoxRenderEngine;
@@ -94,7 +95,7 @@
         XWikiAttachment image = doc.getAttachment(icon);
         String path = "";
         if (image != null) {
-            path = doc.getAttachmentURL(icon, "download", xcontext);
+            path = doc.getAttachmentURL(icon, DocumentAction.DOWNLOAD, xcontext);
         } else {
             icon = "icons/" + icon; // icons default directory that contain icon image. 
             path = xcontext.getWiki().getSkinFile(icon, xcontext);
Index: src/main/java/com/xpn/xwiki/render/macro/AttachMacro.java
===================================================================
--- src/main/java/com/xpn/xwiki/render/macro/AttachMacro.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/render/macro/AttachMacro.java	(working copy)
@@ -30,6 +30,7 @@
 import org.radeox.util.Encoder;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.render.XWikiRadeoxRenderEngine;
 
@@ -125,7 +126,7 @@
         if (filename.indexOf("tp://") != -1) {
             str.append(filename);
         } else {
-            str.append(doc.getAttachmentURL(filename, "download", xcontext));
+            str.append(doc.getAttachmentURL(filename, DocumentAction.DOWNLOAD, xcontext));
         }
         str.append("\"");
         if (rel != null) {
Index: src/main/java/com/xpn/xwiki/render/XWikiRadeoxRenderEngine.java
===================================================================
--- src/main/java/com/xpn/xwiki/render/XWikiRadeoxRenderEngine.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/render/XWikiRadeoxRenderEngine.java	(working copy)
@@ -23,6 +23,7 @@
 package com.xpn.xwiki.render;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.render.filter.XWikiFilter;
 import com.xpn.xwiki.util.Util;
@@ -211,7 +212,7 @@
                  addLinkToContext(newdoc.getFullName(), context);
 
                 URL url = context.getURLFactory().createURL(newdoc.getSpace(), newdoc.getName(),
-                        "view", querystring, anchor, context);
+                        DocumentAction.VIEW, querystring, anchor, context);
                 buffer.append(context.getURLFactory().getURL(url, context));
                 buffer.append("\">");
                 buffer.append(view);
@@ -296,7 +297,7 @@
                 querystring += "&editor=" + editor;
 
             URL url = context.getURLFactory().createURL(newdoc.getSpace(), newdoc.getName(),
-                    "edit", querystring, null, context);
+                    DocumentAction.EDIT, querystring, null, context);
             String surl = context.getURLFactory().getURL(url, context);
             buffer.append("<a class=\"wikicreatelink\" href=\"");
             buffer.append(surl);
Index: src/main/java/com/xpn/xwiki/XWikiContext.java
===================================================================
--- src/main/java/com/xpn/xwiki/XWikiContext.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/XWikiContext.java	(working copy)
@@ -30,6 +30,7 @@
 import org.apache.commons.collections.map.LRUMap;
 import org.apache.xmlrpc.server.XmlRpcServer;
 
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.objects.classes.BaseClass;
 import com.xpn.xwiki.user.api.XWikiUser;
@@ -58,7 +59,7 @@
    private XWikiRequest request;
    private XWikiResponse response;
    private XWikiForm form;
-   private String action;
+   private DocumentAction action;
    private String orig_database;
    private String database;
    private boolean virtual;
@@ -118,11 +119,17 @@
         this.request = request;
     }
 
+    /*
     public String getAction() {
         return action;
     }
+    */
+    
+    public DocumentAction getAction() {
+        return this.action;
+    }
 
-    public void setAction(String action) {
+    public void setAction(DocumentAction action) {
         this.action = action;
     }
 
@@ -308,7 +315,7 @@
         return archiveCache.get(key);
     }
 
-    public void setLinksAction(String action) {
+    public void setLinksAction(DocumentAction action) {
         put("links_action", action);
     }
 
@@ -316,8 +323,8 @@
         remove("links_action");
     }
 
-    public String getLinksAction() {
-        return (String) get("links_action");
+    public DocumentAction getLinksAction() {
+        return (DocumentAction) get("links_action");
     }
 
     public void setLinksQueryString(String value) {
Index: src/main/java/com/xpn/xwiki/monitor/api/MonitorData.java
===================================================================
--- src/main/java/com/xpn/xwiki/monitor/api/MonitorData.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/monitor/api/MonitorData.java	(working copy)
@@ -24,6 +24,8 @@
 import org.apache.commons.logging.Log;
 import org.apache.commons.logging.LogFactory;
 
+import com.xpn.xwiki.api.DocumentAction;
+
 import java.net.URL;
 import java.util.*;
 
@@ -32,7 +34,7 @@
 
     private URL url;
     private String wikiPage;
-    private String action;
+    private DocumentAction action;
     private String threadName;
     private Date startTime;
     private Date endTime;
@@ -41,7 +43,7 @@
     private Map timerSummaries = new HashMap();
     private List timerList = new ArrayList();
 
-    public MonitorData(String wikiPage, String action, URL url, String threadName) {
+    public MonitorData(String wikiPage, DocumentAction action, URL url, String threadName) {
         this.setWikiPage(wikiPage);
         this.setURL(url);
         this.setThreadName(threadName);
@@ -164,7 +166,7 @@
           }
           tsummary.addTimer(timer.getDuration());
             if (log.isDebugEnabled()) {
-                   log.debug("MONITOR " + wikiPage + " " + action + " " + timer.getName() + ": " + timer.getDuration() + "ms " + timer.getDetails());
+                   log.debug("MONITOR " + wikiPage + " " + action.toString() + " " + timer.getName() + ": " + timer.getDuration() + "ms " + timer.getDetails());
             }
         }
     }
@@ -183,7 +185,7 @@
             Iterator it = timerSummaries.values().iterator();
             while (it.hasNext()) {
                 MonitorTimerSummary tsummary = (MonitorTimerSummary) it.next();
-                log.debug("MONITOR " + wikiPage + " " + action + " " + tsummary.getName() + ": " + tsummary.getDuration() + "ms " + tsummary.getNbCalls());
+                log.debug("MONITOR " + wikiPage + " " + action.toString() + " " + tsummary.getName() + ": " + tsummary.getDuration() + "ms " + tsummary.getNbCalls());
             }
         }
     }
@@ -204,11 +206,11 @@
          return tsummary.getNbCalls();
     }
     
-    public String getAction() {
+    public DocumentAction getAction() {
         return action;
     }
 
-    public void setAction(String action) {
+    public void setAction(DocumentAction action) {
         this.action = action;
     }
 
@@ -217,7 +219,7 @@
         str.append("WikiPage: ");
         str.append(wikiPage);
         str.append(" Action: ");
-        str.append(action);
+        str.append(action.toString());
         str.append(" URL: ");
         str.append(url.toString());
         str.append(" Thread: ");
Index: src/main/java/com/xpn/xwiki/monitor/api/MonitorPlugin.java
===================================================================
--- src/main/java/com/xpn/xwiki/monitor/api/MonitorPlugin.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/monitor/api/MonitorPlugin.java	(working copy)
@@ -22,6 +22,7 @@
 package com.xpn.xwiki.monitor.api;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.plugin.XWikiDefaultPlugin;
 import org.apache.commons.collections.buffer.CircularFifoBuffer;
 import org.apache.commons.logging.Log;
@@ -68,7 +69,7 @@
         return "monitor";
     }
 
-    public void startRequest(String page, String action, URL url) {
+    public void startRequest(String page, DocumentAction action, URL url) {
         if (isActive()==false)
             return;
 
